import static javax.swing.JOptionPane.*;

public class TrocaAtletas {
  private static Atleta[] dados;
  private static int qtde;
  
  public static void main(String[] args) {
    dados = new Atleta[50];
    qtde = 0;
    
    while (true) {
      int i = showOptionDialog(null, "Escolha uma opção",
          "Ordenação por Troca - Atletas", 0, 3, null,
          new String[]{"Incluir","Ordenar","Listar"}, "Incluir");
      if (i == -1) System.exit(0);
      if (i == 0) incluir();
      else if (i == 1) ordenar();
      else if (i == 2) listar();
    }
  }
  
  private static void incluir() {
    if (qtde == dados.length) {
      showMessageDialog(null,"Limite excedido","Erro",ERROR_MESSAGE);
      return;
    }
    
    Atleta att = new Atleta();
    String str = showInputDialog("Informe o número do atleta");
    if (str == null) return;
    try { att.setNumero(str); }
    catch(Exception ex) {
      showMessageDialog(null,ex.getMessage(),"Erro",ERROR_MESSAGE);
      return;
    }
    
    str = showInputDialog("Informe o nome do atleta");
    if (str == null) return;
    att.setNome(str);
    
    dados[qtde++] = att;
  }
  
  private static void ordenar() {
    if (qtde == 0) {
      showMessageDialog(null,"Não há dados!","Erro",ERROR_MESSAGE);
      return;
    }
    
    OrdenacaoTroca.ordenar(dados,qtde);
    showMessageDialog(null,"Ordenação concluída!");
  }
  
  private static void listar() {
    if (qtde == 0) {
      showMessageDialog(null,"Não há dados!","Erro",ERROR_MESSAGE);
      return;
    }
    
    String str = "Lista de atletas:";
    for (Atleta a : dados) {
      if (a == null) break;
      str += "\n" + a;
    }
    
    showMessageDialog(null,str);
  }
}

/********************************************************************
 * Este arquivo é parte integrante do livro identificado abaixo e é *
 * protegido pela legislação que trata dos direitos autorais.       *
 *                                                                  *
 * Título:  Programação de Computadores em Java                     *
 * Autor:   Rui Rossi dos Santos                                    *
 * Editora: NovaTerra Editora e Distribuidora Ltda.                 *
 * Ano:     2011                                                    *
 ********************************************************************/
